<template>
  <div class="sw-gs-widget-customer-insights">
    <SfLoader class="widget-loader" :loading="isLoading" v-if="isLoading"/>
    <template v-else>
      <div class="customer-insights-table" v-if="activeClientsExist">

        <div class="customer-insights-table-heading">
          <div>
            {{ $t('Users') }}
          </div>
          <div class="customer-insights-table-heading__cart">
            {{ $t('Cart') }}
          </div>
        </div>

        <div class="customer-insights-table-body">
          <SfAccordion transition="false" showChevron>
            <SwGsAccordionItem v-for="(client, key, index) in clients"
                               :key="client.attendeeId"
                               :header="(index + 1) + '. ' + (client.attendeeName || client.attendeeId)"
                               :textRight="attendeeData && attendeeData.attendees && attendeeData.attendees[client.attendeeId] ? formatPrice(attendeeData.attendees[client.attendeeId].cartSum, {symbol: attendeeData.currencySymbol, separator: '.'}) : ''"
                               :class="currentClientForGuide === client.attendeeId ? 'text-primary' : ''"
                               class="customer-insights-active-client-item customer-insights-client-item"
                               @toggleItem="loadCustomerData(client.attendeeId, $event)">
              <SfLoader :loading="isLoading">
                <InsightsClientItem :client="client"></InsightsClientItem>
              </SfLoader>
            </SwGsAccordionItem>
            <span v-if="clients.length < 1">{{ $t('No active user.') }}</span>
          </SfAccordion>

        </div>
      </div>

      <div class="customer-insights-table" v-if="inactiveClientsExist">

        <div class="customer-insights-table-heading" @click="toggleInactiveUsers">
          <div class="inactive-user-toggle">
            {{ $t('InactiveUsers') }} ...
          </div>
        </div>

        <div class="customer-insights-table-body" v-if="showInactive">
          <SfAccordion transition="false" showChevron>
            <SwGsAccordionItem v-for="(inactiveClient, key, index) in inactiveClients"
                               :key="inactiveClient.attendeeId"
                               :header="(index + 1) + '. ' + (inactiveClient.attendeeName || inactiveClient.attendeeId)"
                               :textRight="attendeeData && attendeeData.attendees && attendeeData.attendees[inactiveClient.attendeeId] ? formatPrice(attendeeData.attendees[inactiveClient.attendeeId].cartSum, {symbol: attendeeData.currencySymbol, separator: '.'}) : ''"
                               class="customer-insights-inactive-client-item customer-insights-client-item"
                               @toggleItem="loadCustomerData(inactiveClient.attendeeId, $event)">
              <SfLoader :loading="isLoading">
                <InsightsClientItem :client="inactiveClient" :isActive="false"></InsightsClientItem>
              </SfLoader>
            </SwGsAccordionItem>
          </SfAccordion>


        </div>
      </div>

    </template>
  </div>
</template>

<script lang="ts">
  import { SfAccordion, SfLoader } from "@storefront-ui/vue";
  import { computed, ref } from '@vue/composition-api';
  import { useState } from "../../logic/composables/useState";
  import { useCustomerInsights } from "../../logic/composables/widgets/useCustomerInsights";
  import SwGsAccordionItem from "../layer/SwGsAccordionItem.vue";
  import InsightsClientItem from "./customer-insights/InsightsClientItem.vue";
  import { usePriceFilter } from "../../logic/composables/usePriceFilter";

  export default {
    name: "SwGsCustomerInsights",
    components: {
      SfLoader,
      SfAccordion,
      SwGsAccordionItem,
      InsightsClientItem
    },
    setup({}, {}) {
      const { formatPrice } = usePriceFilter();

      const {
        loadCustomerData,
        customerData,
        attendeeData,
        loadAttendeeData,
        isLoading,
      } = useCustomerInsights();
      const {
        stateForGuides,
        currentClientForGuide
      } = useState();

      const showInactive = ref(false);

      loadAttendeeData();

      function toggleInactiveUsers() {
        showInactive.value = !showInactive.value
      }

      return {
        clients: computed(() => stateForGuides?.value?.clients),
        inactiveClients: computed(() => stateForGuides?.value?.inactiveClients),
        activeClientsExist: computed(() => Object.keys(stateForGuides?.value?.clients).length > 0),
        inactiveClientsExist: computed(() => Object.keys(stateForGuides?.value?.inactiveClients).length > 0),
        showInactive: computed(() => showInactive.value),
        currentClientForGuide,
        customerData,
        attendeeData,
        toggleInactiveUsers,
        loadCustomerData,
        isLoading,
        formatPrice
      }
    }
  }
</script>

<style lang="scss" scoped>
  @import "@/assets/scss/variables";

  .widget-loader {
    height: 50px;
  }

  .customer-insights-table-heading {
    padding: 3px 0;
    margin-bottom: 3px;
    border-bottom: 2px solid var(--c-primary);
    display: flex;
    justify-content: space-between;
    font-size: var(--font-size--sm);
    font-weight: 500;

    &.is-inactive {
      margin-top: 10px;
    }

    .customer-insights-table-heading__cart {
      padding-right: 30px;
      font-weight: 500;
    }

    .inactive-user-toggle {
      cursor: pointer;
    }
  }

  .customer-insights-active-client-item {

    ::v-deep .sf-accordion-item__icon-text-wrapper {
      width: 65%;

      .sf-accordion-item__text {
        overflow: hidden;
        text-overflow: ellipsis;
        white-space: nowrap;
      }
    }

  }

  .customer-insights-table-body {
    &, ::v-deep .sf-accordion-item__text {
      font-size: var(--font-size--sm);
    }

    ::v-deep {
      .sf-accordion-item__header {
        padding: 5px 0;
        margin-bottom: 5px;
        border-bottom: 2px solid var(--c-primary);
      }

      .sf-accordion-item__content {
        min-height: 90px;
        font-size: var(--font-size--sm);
        padding: var(--spacer-xs);
        background-color: var(--c-light);
      }

      .sf-loader__overlay {
        background: none;
        padding-top: 45px;
      }
    }
  }
</style>
